#ifndef __I_ROWSET_EXACT_SCROLL_IMPL__INCLUDED__
#define __I_ROWSET_EXACT_SCROLL_IMPL__INCLUDED__

#include "IRowsetScrollImpl.h"

template <class T, class Base>
class ATL_NO_VTABLE CRowsetExactScrollImpl;

template <class T>
class ATL_NO_VTABLE IRowsetExactScrollImpl : public CRowsetExactScrollImpl<T, IRowsetExactScroll>
{
};

template <class T, class Base>
class ATL_NO_VTABLE CRowsetExactScrollImpl : public CRowsetScrollImpl<T, Base>
{
   public:

      STDMETHOD(GetExactPosition)(
		   HCHAPTER hChapter,
		   ULONG cbBookmark,
		   const BYTE *pBookmark,
		   ULONG *pulPosition,
		   ULONG *pcRows)
      {
         ATLTRACE2(atlTraceDBProvider, 0, "IRowsetExactScroll::GetExactPosition()\n");

         // Our GetApproximatePosition actually gives the exact position

         return GetApproximatePosition(hChapter, cbBookmark, pBookmark, pulPosition, pcRows);
      }
};

#endif // __I_ROWSET_EXACT_SCROLL_IMPL__INCLUDED__
